searchNodes=[{"doc":"SurrealDB driver for BEAM ecosystem.","ref":"surreal.html","title":"surreal","type":"module"},{"doc":"Authenticates the current connection with a JWT token. 1 &gt; Token = &quot;eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJpc...&quot; . % &quot;eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJpc...&quot; 2 &gt; surreal : authenticate ( Pid , Token ) . % {ok,null}","ref":"surreal.html#authenticate/2","title":"surreal.authenticate/2","type":"function"},{"doc":"Child specification for SurrealDB Erlang.","ref":"surreal.html#child_spec/1","title":"surreal.child_spec/1","type":"function"},{"doc":"Closes the persistent connection to the database. 1 &gt; surreal : close ( Pid ) . % ok","ref":"surreal.html#close/1","title":"surreal.close/1","type":"function"},{"doc":"Creates a record in the database. 1 &gt; User = \#{ &lt;&lt; &quot;name&quot; &gt;&gt; =&gt; &lt;&lt; &quot;meppu&quot; &gt;&gt; , &lt;&lt; &quot;identify&quot; &gt;&gt; =&gt; &lt;&lt; &quot;cat&quot; &gt;&gt; } . % \#{&lt;&lt;&quot;identify&quot;&gt;&gt; =&gt; &lt;&lt;&quot;cat&quot;&gt;&gt;,&lt;&lt;&quot;name&quot;&gt;&gt; =&gt; &lt;&lt;&quot;meppu&quot;&gt;&gt;} 2 &gt; { ok , Created } = surreal : create ( Pid , { &quot;users&quot; , &quot;meppu&quot; } , User ) . % {ok,\#{&lt;&lt;&quot;id&quot;&gt;&gt; =&gt; &lt;&lt;&quot;users:meppu&quot;&gt;&gt;,&lt;&lt;&quot;identify&quot;&gt;&gt; =&gt; &lt;&lt;&quot;cat&quot;&gt;&gt;, % &lt;&lt;&quot;name&quot;&gt;&gt; =&gt; &lt;&lt;&quot;meppu&quot;&gt;&gt;}} 3 &gt; { ok , Created2 } = surreal : create ( Pid , &quot;users&quot; , User ) . % {ok,[\#{&lt;&lt;&quot;id&quot;&gt;&gt; =&gt; &lt;&lt;&quot;users:pmqsma4cqhescl1wlsi1&quot;&gt;&gt;, % &lt;&lt;&quot;identify&quot;&gt;&gt; =&gt; &lt;&lt;&quot;cat&quot;&gt;&gt;,&lt;&lt;&quot;name&quot;&gt;&gt; =&gt; &lt;&lt;&quot;meppu&quot;&gt;&gt;}]}","ref":"surreal.html#create/3","title":"surreal.create/3","type":"function"},{"doc":"Deletes all records in a table, or a specific record, from the database. 1 &gt; { ok , Deleted } = surreal : merge ( Pid , { &quot;users&quot; , &quot;meppu&quot; } ) . % {ok,\#{&lt;&lt;&quot;id&quot;&gt;&gt; =&gt; &lt;&lt;&quot;users:meppu&quot;&gt;&gt;,&lt;&lt;&quot;identify&quot;&gt;&gt; =&gt; &lt;&lt;&quot;human&quot;&gt;&gt;, % &lt;&lt;&quot;name&quot;&gt;&gt; =&gt; &lt;&lt;&quot;meppu&quot;&gt;&gt;,&lt;&lt;&quot;score&quot;&gt;&gt; =&gt; 10}}","ref":"surreal.html#delete/2","title":"surreal.delete/2","type":"function"},{"doc":"Inserts one or multiple records in the database. 1 &gt; AuthorisedUsers = [ \#{ &lt;&lt; &quot;user&quot; &gt;&gt; =&gt; &lt;&lt; &quot;A&quot; &gt;&gt; } , \#{ &lt;&lt; &quot;user&quot; &gt;&gt; =&gt; &lt;&lt; &quot;B&quot; &gt;&gt; } ] . % [\#{&lt;&lt;&quot;user&quot;&gt;&gt; =&gt; &lt;&lt;&quot;A&quot;&gt;&gt;},\#{&lt;&lt;&quot;user&quot;&gt;&gt; =&gt; &lt;&lt;&quot;B&quot;&gt;&gt;}] 2 &gt; { ok , Created } = surreal : insert ( Pid , &quot;authorised&quot; , AuthorisedUsers ) . % {ok,[\#{&lt;&lt;&quot;id&quot;&gt;&gt; =&gt; &lt;&lt;&quot;authorised:3n4mn5wsq823i7pgv9un&quot;&gt;&gt;, % &lt;&lt;&quot;user&quot;&gt;&gt; =&gt; &lt;&lt;&quot;A&quot;&gt;&gt;}, % \#{&lt;&lt;&quot;id&quot;&gt;&gt; =&gt; &lt;&lt;&quot;authorised:raedq65doxhpuc6t3meo&quot;&gt;&gt;, % &lt;&lt;&quot;user&quot;&gt;&gt; =&gt; &lt;&lt;&quot;B&quot;&gt;&gt;}]}","ref":"surreal.html#insert/3","title":"surreal.insert/3","type":"function"},{"doc":"Invalidates the authentication for the current connection. 1 &gt; surreal : invalidate ( Pid ) . % {ok,null}","ref":"surreal.html#invalidate/1","title":"surreal.invalidate/1","type":"function"},{"doc":"Modifies all records in a table, or a specific record, in the database. This function merges the current document/record data with the specified data. 1 &gt; MergeData = \#{ &lt;&lt; &quot;score&quot; &gt;&gt; =&gt; 10 } . % \#{&lt;&lt;&quot;score&quot;&gt;&gt; =&gt; 10} 2 &gt; { ok , Updated } = surreal : merge ( Pid , { &quot;users&quot; , &quot;meppu&quot; } , MergeData ) . % {ok,\#{&lt;&lt;&quot;id&quot;&gt;&gt; =&gt; &lt;&lt;&quot;users:meppu&quot;&gt;&gt;,&lt;&lt;&quot;identify&quot;&gt;&gt; =&gt; &lt;&lt;&quot;human&quot;&gt;&gt;, % &lt;&lt;&quot;name&quot;&gt;&gt; =&gt; &lt;&lt;&quot;meppu&quot;&gt;&gt;,&lt;&lt;&quot;score&quot;&gt;&gt; =&gt; 10}}","ref":"surreal.html#merge/3","title":"surreal.merge/3","type":"function"},{"doc":"Applies JSON Patch changes to all records, or a specific record, in the database. This function patches the current document/record data with the specified JSON Patch data. 1 &gt; Patches = [ { replace , &quot;/name&quot; , &lt;&lt; &quot;tuhana&quot; &gt;&gt; } , { remove , &quot;/score&quot; } ] . % [{replace,&quot;/name&quot;,&lt;&lt;&quot;tuhana&quot;&gt;&gt;},{remove,&quot;/score&quot;}] 2 &gt; surreal : patch ( database , { &quot;users&quot; , &quot;meppu&quot; } , Patches ) . % {ok,[\#{&lt;&lt;&quot;op&quot;&gt;&gt; =&gt; &lt;&lt;&quot;remove&quot;&gt;&gt;,&lt;&lt;&quot;path&quot;&gt;&gt; =&gt; &lt;&lt;&quot;/score&quot;&gt;&gt;, % &lt;&lt;&quot;value&quot;&gt;&gt; =&gt; null}, % \#{&lt;&lt;&quot;op&quot;&gt;&gt; =&gt; &lt;&lt;&quot;change&quot;&gt;&gt;,&lt;&lt;&quot;path&quot;&gt;&gt; =&gt; &lt;&lt;&quot;/name&quot;&gt;&gt;, % &lt;&lt;&quot;value&quot;&gt;&gt; =&gt; &lt;&lt;&quot;@ -1,5 +1,6 @\\n-meppu\\n+tuhana\\n&quot;&gt;&gt;}]}","ref":"surreal.html#patch/3","title":"surreal.patch/3","type":"function"},{"doc":"Ping SurrealDB instance. 1 &gt; surreal : ping ( Pid ) . % {ok,null}","ref":"surreal.html#ping/1","title":"surreal.ping/1","type":"function"},{"doc":"Executes a set of SurrealQL statements against the database. 1 &gt; [ { ok , Result } ] = surreal : query ( Pid , &quot;SELECT * FROM authorised&quot; ) . % {ok,[\#{&lt;&lt;&quot;id&quot;&gt;&gt; =&gt; &lt;&lt;&quot;authorised:3n4mn5wsq823i7pgv9un&quot;&gt;&gt;, % &lt;&lt;&quot;user&quot;&gt;&gt; =&gt; &lt;&lt;&quot;A&quot;&gt;&gt;}, % \#{&lt;&lt;&quot;id&quot;&gt;&gt; =&gt; &lt;&lt;&quot;authorised:raedq65doxhpuc6t3meo&quot;&gt;&gt;, % &lt;&lt;&quot;user&quot;&gt;&gt; =&gt; &lt;&lt;&quot;B&quot;&gt;&gt;}]}","ref":"surreal.html#query/2","title":"surreal.query/2","type":"function"},{"doc":"Executes a set of SurrealQL statements against the database with variables. This function is similar to query/2 , but allows you to provide a map of variables that can be used in the query. This can be useful for dynamic queries where you need to parametrise certain parts of the query. 1 &gt; [ { ok , Result } ] = surreal : query ( Pid , &quot;SELECT * FROM authorised WHERE user = $user&quot; , \#{ &lt;&lt; &quot;user&quot; &gt;&gt; =&gt; &lt;&lt; &quot;A&quot; &gt;&gt; } ) . % [{ok,[\#{&lt;&lt;&quot;id&quot;&gt;&gt; =&gt; &lt;&lt;&quot;authorised:3n4mn5wsq823i7pgv9un&quot;&gt;&gt;, % &lt;&lt;&quot;user&quot;&gt;&gt; =&gt; &lt;&lt;&quot;A&quot;&gt;&gt;}]}]","ref":"surreal.html#query/3","title":"surreal.query/3","type":"function"},{"doc":"Retrieves all records in a table or a specific record. 1 &gt; { ok , Result } = surreal : select ( Pid , &quot;authorised&quot; ) . % {ok,[\#{&lt;&lt;&quot;id&quot;&gt;&gt; =&gt; &lt;&lt;&quot;authorised:3n4mn5wsq823i7pgv9un&quot;&gt;&gt;, % &lt;&lt;&quot;user&quot;&gt;&gt; =&gt; &lt;&lt;&quot;A&quot;&gt;&gt;}, % \#{&lt;&lt;&quot;id&quot;&gt;&gt; =&gt; &lt;&lt;&quot;authorised:raedq65doxhpuc6t3meo&quot;&gt;&gt;, % &lt;&lt;&quot;user&quot;&gt;&gt; =&gt; &lt;&lt;&quot;B&quot;&gt;&gt;}]} 2 &gt; { ok , Result2 } = surreal : select ( Pid , { &quot;users&quot; , &quot;meppu&quot; } ) . % {ok,\#{&lt;&lt;&quot;id&quot;&gt;&gt; =&gt; &lt;&lt;&quot;users:meppu&quot;&gt;&gt;,&lt;&lt;&quot;identify&quot;&gt;&gt; =&gt; &lt;&lt;&quot;cat&quot;&gt;&gt;, % &lt;&lt;&quot;name&quot;&gt;&gt; =&gt; &lt;&lt;&quot;meppu&quot;&gt;&gt;}}","ref":"surreal.html#select/2","title":"surreal.select/2","type":"function"},{"doc":"Creates a variable that can be used throughout the database session. 1 &gt; surreal : set ( Pid , &quot;PI&quot; , 3.14 ) . % {ok,null}","ref":"surreal.html#set/3","title":"surreal.set/3","type":"function"},{"doc":"Signs in to a root, namespace, database or scope user. For more information about Vars , view SurrealDB documentation and the JavaScript SDK . 1 &gt; Vars = \#{ &lt;&lt; &quot;DB&quot; &gt;&gt; =&gt; &lt;&lt; &quot;test&quot; &gt;&gt; , &lt;&lt; &quot;NS&quot; &gt;&gt; =&gt; &lt;&lt; &quot;test&quot; &gt;&gt; , 1 &gt; &lt;&lt; &quot;SC&quot; &gt;&gt; =&gt; &lt;&lt; &quot;user&quot; &gt;&gt; , 1 &gt; &lt;&lt; &quot;email&quot; &gt;&gt; =&gt; &lt;&lt; &quot;info@surrealdb.com&quot; &gt;&gt; , 1 &gt; &lt;&lt; &quot;pass&quot; &gt;&gt; =&gt; &lt;&lt; &quot;123456&quot; &gt;&gt; } . % \#{...} 2 &gt; surreal : signin ( Pid , Vars ) . % {ok, &lt;&lt;&quot;eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJpc&quot;...&gt;&gt;}","ref":"surreal.html#signin/2","title":"surreal.signin/2","type":"function"},{"doc":"Signs in to the database with a username and password. 1 &gt; surreal : signin ( Pid , &quot;root&quot; , &quot;root&quot; ) . % {ok,null}","ref":"surreal.html#signin/3","title":"surreal.signin/3","type":"function"},{"doc":"Signs up a user to a specific authentication scope. For more information about Vars , view SurrealDB documentation and the JavaScript SDK . 1 &gt; Vars = \#{ &lt;&lt; &quot;DB&quot; &gt;&gt; =&gt; &lt;&lt; &quot;test&quot; &gt;&gt; , &lt;&lt; &quot;NS&quot; &gt;&gt; =&gt; &lt;&lt; &quot;test&quot; &gt;&gt; , 1 &gt; &lt;&lt; &quot;SC&quot; &gt;&gt; =&gt; &lt;&lt; &quot;user&quot; &gt;&gt; , 1 &gt; &lt;&lt; &quot;email&quot; &gt;&gt; =&gt; &lt;&lt; &quot;info@surrealdb.com&quot; &gt;&gt; , 1 &gt; &lt;&lt; &quot;pass&quot; &gt;&gt; =&gt; &lt;&lt; &quot;123456&quot; &gt;&gt; } . % \#{...} 2 &gt; surreal : signup ( Pid , Vars ) . % {ok, &lt;&lt;&quot;eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJpc&quot;...&gt;&gt;}","ref":"surreal.html#signup/2","title":"surreal.signup/2","type":"function"},{"doc":"Establishes a connection to a local or remote database endpoint. - Uri must be a valid SurrealDB URI. For more information, visit surreal_config . - ConnName allows you to set a name for the connection, so you can use the given name instead of pid while using SurrealDB. 1 &gt; Uri = &quot;surrealdb://root:root@localhost:8000/surrealdb/docs&quot; . % &quot;surrealdb://root:root@localhost:8000/surrealdb/docs&quot; 2 &gt; { ok , Pid } = surreal : start_link ( Uri , database ) . % {ok,&lt;0.359.0&gt;}","ref":"surreal.html#start_link/2","title":"surreal.start_link/2","type":"function"},{"doc":"Connects to a local or remote database endpoint with additional options. Essentially the same as surreal:start_link/2 but with an extra argument: - Opts allows you to provide custom options. 1 &gt; Uri = &quot;surrealdb://root:root@localhost:8000/surrealdb/docs&quot; . % &quot;surrealdb://root:root@localhost:8000/surrealdb/docs&quot; 2 &gt; { ok , Pid } = surreal : start_link ( Uri , database , \#{ use =&gt; false } ) . % {ok,&lt;0.359.0&gt;}","ref":"surreal.html#start_link/3","title":"surreal.start_link/3","type":"function"},{"doc":"Removes a variable from the current socket connection. 1 &gt; surreal : unset ( Pid , &quot;PI&quot; ) . % {ok,null}","ref":"surreal.html#unset/2","title":"surreal.unset/2","type":"function"},{"doc":"Updates all records in a table, or a specific record, in the database. This function replaces the current document/record data with the specified data. 1 &gt; NewData = \#{ &lt;&lt; &quot;name&quot; &gt;&gt; =&gt; &lt;&lt; &quot;meppu&quot; &gt;&gt; , &lt;&lt; &quot;identify&quot; &gt;&gt; =&gt; &lt;&lt; &quot;human&quot; &gt;&gt; } . % \#{&lt;&lt;&quot;identify&quot;&gt;&gt; =&gt; &lt;&lt;&quot;human&quot;&gt;&gt;,&lt;&lt;&quot;name&quot;&gt;&gt; =&gt; &lt;&lt;&quot;meppu&quot;&gt;&gt;} 2 &gt; { ok , Updated } = surreal : update ( Pid , { &quot;users&quot; , &quot;meppu&quot; } , NewData ) . % {ok,\#{&lt;&lt;&quot;id&quot;&gt;&gt; =&gt; &lt;&lt;&quot;users:meppu&quot;&gt;&gt;,&lt;&lt;&quot;identify&quot;&gt;&gt; =&gt; &lt;&lt;&quot;human&quot;&gt;&gt;, % &lt;&lt;&quot;name&quot;&gt;&gt; =&gt; &lt;&lt;&quot;meppu&quot;&gt;&gt;}}","ref":"surreal.html#update/3","title":"surreal.update/3","type":"function"},{"doc":"Switches to a specific namespace and database. 1 &gt; surreal : use ( Pid , &quot;test&quot; , &quot;test&quot; ) . % {ok,null}","ref":"surreal.html#use/3","title":"surreal.use/3","type":"function"},{"doc":"This is utilised to define options for the sign-in process. It offers three possible options: true This is the default option, and it indicates that the sign-in process is enabled and should be used with the given URI. false This option stands for disabling the sign-in process entirely. (Vars :: map()) This option provides flexibility for custom sign-in options.","ref":"surreal.html#t:signin_opts/0","title":"surreal.signin_opts/0","type":"type"},{"doc":"","ref":"surreal.html#t:surreal_opts/0","title":"surreal.surreal_opts/0","type":"type"},{"doc":"","ref":"surreal.html#t:surreal_pid/0","title":"surreal.surreal_pid/0","type":"type"},{"doc":"This type represents a boolean value. It is used to determine whether specific database and namespace settings should be used or not. Default is true .","ref":"surreal.html#t:use_opts/0","title":"surreal.use_opts/0","type":"type"},{"doc":"Connection configuration module for SurrealDB Erlang. SurrealDB URI Format The SurrealDB URI format is an unofficial way to represent connection information for accessing SurrealDB. It allows users to define various parameters necessary for establishing a connection to the database server. This format has been adopted and enhanced from mylk , a SurrealDB driver for Ruby. The URI format follows this format: - Plain TCP : surrealdb://username:password@host:port/namespace/database - TLS : surrealdb+tls://username:password@host:port/namespace/database Scheme This is the scheme used to identify SurrealDB connections. The optional &quot;tls&quot; part indicates that the connection should be made over TLS (Transport Layer Security), providing a secure and encrypted communication channel. Credentials The username and password to authenticate with the SurrealDB server. Host The hostname or IP address of the SurrealDB server. Namespace The name of the SurrealDB namespace that you want to use. Database The name of the SurrealDB database that you want to use. Timeout Timeout for the operations in milliseconds. Default is 5000 (5 seconds). Example URI Default for SurrealDB : surrealdb://root:root@localhost:8000/test/test Default for SurrealDB with 10s timeout : surrealdb://root:root@localhost:8000/test/test?timeout=10000","ref":"surreal_config.html","title":"surreal_config","type":"module"},{"doc":"Parse SurrealDB URI. 1 &gt; surreal_config : parse ( &quot;surrealdb://root:root@localhost:8000/test/test&quot; ) . % {ok,\#{database =&gt; &quot;test&quot;,host =&gt; &quot;localhost&quot;,namespace =&gt; &quot;test&quot;, % password =&gt; &quot;root&quot;,port =&gt; 8000,timeout =&gt; 5000, % tls =&gt; false,username =&gt; &quot;root&quot;}}","ref":"surreal_config.html#parse/1","title":"surreal_config.parse/1","type":"function"},{"doc":"","ref":"surreal_config.html#t:connection_map/0","title":"surreal_config.connection_map/0","type":"type"},{"doc":"Module for representing Table or Record ID.","ref":"surreal_entity.html","title":"surreal_entity","type":"module"},{"doc":"Converts given thing() to entity_identifier() .","ref":"surreal_entity.html#convert/1","title":"surreal_entity.convert/1","type":"function"},{"doc":"An identifier that serves as a unique reference for entities within a database, encompassing both database tables and record identifiers. - &quot;employees&quot; : Represents the table containing employee records. - &quot;employees:meppu&quot; : Identifies a specific employee record.","ref":"surreal_entity.html#t:entity_identifier/0","title":"surreal_entity.entity_identifier/0","type":"type"},{"doc":"A tuple representing a database record's location using the table name and a unique identifier. - {&quot;employees&quot;, &quot;meppu&quot;} : Refers to an employee record in the employees table.","ref":"surreal_entity.html#t:record_specification/0","title":"surreal_entity.record_specification/0","type":"type"},{"doc":"A type that can represent either an entity identifier or a record specification.","ref":"surreal_entity.html#t:thing/0","title":"surreal_entity.thing/0","type":"type"},{"doc":"Erlang-y JSON patch. Note that this module doesn't implement JSON patch itself but provides types and converters to make surreal:patch/3 easier. You can learn more about JSON Patch here .","ref":"surreal_patch.html","title":"surreal_patch","type":"module"},{"doc":"Converts a given JSON Patch tuple or list into a corresponding map or list.","ref":"surreal_patch.html#convert/1","title":"surreal_patch.convert/1","type":"function"},{"doc":"Combination of all patch types.","ref":"surreal_patch.html#t:patch/0","title":"surreal_patch.patch/0","type":"type"},{"doc":"Adds a value to an object or inserts it into an array. In the case of an array, the value is inserted before the given index. The - character can be used instead of an index to insert at the end of an array.","ref":"surreal_patch.html#t:patch_add/0","title":"surreal_patch.patch_add/0","type":"type"},{"doc":"Copies a value from one location to another within the JSON document. Both From and Path are JSON Pointers.","ref":"surreal_patch.html#t:patch_copy/0","title":"surreal_patch.patch_copy/0","type":"type"},{"doc":"Applies a diff to the document. Value field contains the actual diff to be applied.","ref":"surreal_patch.html#t:patch_diff/0","title":"surreal_patch.patch_diff/0","type":"type"},{"doc":"Moves a value from one location to the other. Both From and Path are JSON Pointers.","ref":"surreal_patch.html#t:patch_move/0","title":"surreal_patch.patch_move/0","type":"type"},{"doc":"Removes a value from an object or array.","ref":"surreal_patch.html#t:patch_remove/0","title":"surreal_patch.patch_remove/0","type":"type"},{"doc":"Replaces a value. Equivalent to a &quot;remove&quot; followed by an &quot;add&quot;.","ref":"surreal_patch.html#t:patch_replace/0","title":"surreal_patch.patch_replace/0","type":"type"},{"doc":"Tests that the specified value is set in the document. If the test fails, then the patch as a whole should not apply.","ref":"surreal_patch.html#t:patch_test/0","title":"surreal_patch.patch_test/0","type":"type"},{"doc":"Result types for SurrealDB driver.","ref":"surreal_result.html","title":"surreal_result","type":"module"},{"doc":"","ref":"surreal_result.html#t:inner_result/0","title":"surreal_result.inner_result/0","type":"type"},{"doc":"","ref":"surreal_result.html#t:ok/0","title":"surreal_result.ok/0","type":"type"},{"doc":"","ref":"surreal_result.html#t:query_error/0","title":"surreal_result.query_error/0","type":"type"},{"doc":"","ref":"surreal_result.html#t:result/0","title":"surreal_result.result/0","type":"type"},{"doc":"","ref":"surreal_result.html#t:server_error/0","title":"surreal_result.server_error/0","type":"type"},{"doc":"","ref":"readme.html","title":"README","type":"extras"},{"doc":"SurrealDB driver for BEAM ecosystem ⚠️ You are currently viewing version 2 ⚠️ SurrealDB Erlang, also referred to as &quot;surreal&quot;, is a robust and maintainable SurrealDB driver for BEAM ecosystem. The library draws inspiration from the official surrealdb.js implementation.","ref":"readme.html#surrealdb-erlang","title":"README - SurrealDB Erlang","type":"extras"},{"doc":"Index Installation Getting Started Creating a Connection Example Usage With Supervisor Additional Examples Documentation Contributing Note for Contributors License","ref":"readme.html#index","title":"README - Index","type":"extras"},{"doc":"SurrealDB Erlang is available on Hex.pm . Add surreal to your list of dependencies in rebar.config file: { deps , [ { surreal , &quot;2.1.0&quot; } ] } .","ref":"readme.html#installation","title":"README - Installation","type":"extras"},{"doc":"Creating a Connection You can establish a database connection with surreal:start_link/2 (or surreal:start_link/3 ). Check out SurrealDB URI format described in the documentation . { ok , Pid } = surreal : start_link ( &quot;surrealdb://root:root@localhost:8000/test/test&quot; , my_connection ) . Alternatively, you can use the specified connection name, my_connection , in place of Pid , as shown below: { ok , Users } = surreal : select ( my_connection , &quot;users&quot; ) . Example Usage SurrealDB Erlang offers users a clean API, demonstrated below: 1 &gt; { ok , User } = surreal : create ( Pid , &quot;users:meppu&quot; , \#{ &lt;&lt; &quot;score&quot; &gt;&gt; =&gt; 10 } ) . % {ok,\#{&lt;&lt;&quot;id&quot;&gt;&gt; =&gt; &lt;&lt;&quot;users:meppu&quot;&gt;&gt;,&lt;&lt;&quot;score&quot;&gt;&gt; =&gt; 10}} 2 &gt; { ok , NewUser } = surreal : merge ( Pid , &quot;users:meppu&quot; , \#{ &lt;&lt; &quot;new&quot; &gt;&gt; =&gt; &lt;&lt; &quot;key&quot; &gt;&gt; } ) . % {ok,\#{&lt;&lt;&quot;id&quot;&gt;&gt; =&gt; &lt;&lt;&quot;users:meppu&quot;&gt;&gt;,&lt;&lt;&quot;new&quot;&gt;&gt; =&gt; &lt;&lt;&quot;key&quot;&gt;&gt;, % &lt;&lt;&quot;score&quot;&gt;&gt; =&gt; 10}} 3 &gt; [ { ok , QueryResp } ] = surreal : query ( Pid , &quot;SELECT * FROM users WHERE score = $score&quot; , \#{ &lt;&lt; &quot;score&quot; &gt;&gt; =&gt; 10 } ) . % [{ok,[\#{&lt;&lt;&quot;id&quot;&gt;&gt; =&gt; &lt;&lt;&quot;users:meppu&quot;&gt;&gt;,&lt;&lt;&quot;new&quot;&gt;&gt; =&gt; &lt;&lt;&quot;key&quot;&gt;&gt;, % &lt;&lt;&quot;score&quot;&gt;&gt; =&gt; 10}]}] 4 &gt; { ok , RemovedUser } = surreal : delete ( Pid , &quot;users:meppu&quot; ) . % {ok,\#{&lt;&lt;&quot;id&quot;&gt;&gt; =&gt; &lt;&lt;&quot;users:meppu&quot;&gt;&gt;,&lt;&lt;&quot;new&quot;&gt;&gt; =&gt; &lt;&lt;&quot;key&quot;&gt;&gt;, % &lt;&lt;&quot;score&quot;&gt;&gt; =&gt; 10}} 5 &gt; RemovedUser =:= NewUser . % true With Supervisor The recommended approach to initialise a SurrealDB connection is through a supervisor. You can use surreal:child_spec/1 to create a child specification for your supervisor, as shown below: ChildSpecs = [ surreal : child_spec ( { &quot;surrealdb://root:root@localhost:8000/test/test&quot; , db_conn , \#{ } } ) ] , Additional Examples See additional examples in examples/ folder.","ref":"readme.html#getting-started","title":"README - Getting Started","type":"extras"},{"doc":"For detailed documentation, please refer to HexDocs .","ref":"readme.html#documentation","title":"README - Documentation","type":"extras"},{"doc":"Feel free to report bugs and request features through GitHub Issues . If you wish to submit a pull request, ensure that your code is well-formatted and easily comprehensible. Note for Contributors Please send your pull requests to v2 branch instead of the main branch. This helps us demostrate a stable version on the main branch while allowing for ongoing development and improvements on the v2 branch.","ref":"readme.html#contributing","title":"README - Contributing","type":"extras"},{"doc":"SurrealDB Erlang is licensed under the MIT License.","ref":"readme.html#license","title":"README - License","type":"extras"},{"doc":"Copyright (C) 2023 meppu meppu@proton.me Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"The MIT License","type":"extras"}]